;This file is copyright (c) 1991, 1992 Informant Communications Group and the
;article author. The material here may be used in an application provided
;that this copyright/disclaimer information is kept in the original source
;file. The material presented here is provided "as is" and with no guarantee.
;Informant Communications Group/Paradox Informant assume no responsibility
;for the use or misuse of the material contained within.
;
;Contents        : procedure Objects.Initialize,
;                            Objects.Create
;                            Objects.Events
;                            Objects.Destroy
;                            CancelNotes
;                            PlayMusic
;                            InsertNote
;                            DeleteNote
;                            RefreshNotes
;                            PianoCursor
;                            JumpCursor
;                            BackOne
;                            SoundOff
;                            ForwardOne
;                            Note
;                            RefreshNote
;                            SaveNotes
;                            OOPiano
;
;Source File     : OOPIANO.ZIP
;Author          : Tony Goodman
;                  Ensemble Corporation
;                  9723 Edgepine
;                  Dallas, TX  75238
;                  (214) 341-6789
;
;Informant Issue : September 1992
;
;Description     : An Object-Oriented PAL Piano Sound Recorder
;                  
;
; Paradox Informant
; 10519 E. Stockton Blvd.
; Suite 142
; Elk Grove, CA  95624-9743
; Phone: (916) 686-6610
; Fax  : (916) 686-8497
; BBS  : (916) 686-4740
;---------------------------------------------------------------------


;Object Oriented Library

LibName="OOPiano"
CreateLib LibName

Proc Objects.Initialize()
     Dynarray Object.HotKeys[]
     Dynarray Object.Handles[]
EndProc
Writelib LibName Objects.Initialize      
release Procs Objects.Initialize

Proc OBJECTS.CREATE(ProcName,Freq,Dur,AtRow,AtCol,High,Wide,GUI,Floating
                   ,Label,ColorOut,ColorIn,HotKey)
     Private WinAttrib,Temp.Handle
 
     DynArray WinAttrib[]
     WinAttrib["OriginCol"]=AtCol
     WinAttrib["OriginRow"]=AtRow
     WinAttrib["CanvasHeight"]=High
     WinAttrib["CanvasWidth"]=Wide
     WinAttrib["HasFrame"]=false
     WinAttrib["HasShadow"]=false
     WinAttrib["Floating"]=(Floating=True)
     WinAttrib["Style"]=ColorOut

     Window Create Attributes WinAttrib To Temp.Handle
     
     Frame from 0,0 to High-1,Wide-1
     If Upper(StrVal(GUI))="TRUE" then
        PaintCanvas Border Attribute 112 0,0,High-1,Wide-1
        PaintCanvas Border Attribute 127 0,0,0,Wide-2
        PaintCanvas Border Attribute 127 0,0,High-1,0
        PaintCanvas Fill Label Attribute ColorOut 1,1,High-2,Wide-2
     Else
        PaintCanvas Fill Label Attribute ColorOut 0,0,High-1,Wide-1 
     Endif
         
     Object.Hotkeys[HotKey]=Temp.Handle
     
     Object.Handles[Temp.Handle]=ProcName+","+
                                 Strval(Freq)+","+
                                 Strval(Dur)+","+
                                 Strval(AtRow)+","+
                                 Strval(AtCol)+","+
                                 Strval(High)+","+
                                 Strval(Wide)+","+
                                 Strval(GUI)+","+
                                 Strval(Floating)+","+
                                 Label+","+
                                 Strval(ColorOut)+","+
                                 Strval(ColorIn)+","+
                                 Strval(HotKey)
EndProc
Writelib LibName Objects.Create      
release Procs Objects.Create

Proc OBJECTS.EVENTS()
     Private Objet.Handle,ProcName,Freq,Dur,AtRow,AtCol,High,Wide,GUI,
             Floating,Label,ColorOut,ColorIn,HotKey

     Echo Normal     
     While True
         GetEvent Key "ALL"  Mouse "Auto","DOWN"  to EVENT1

         Switch
            Case EVENT1["Type"]="MOUSE" :
                 Object.Handle=WindowAt(EVENT1["ROW"],EVENT1["COL"]) 
                 if isassigned(Object.Handles[Object.Handle]) then
                    Object.String=Object.Handles[Object.Handle]
                 Else
                   Loop
                 Endif
                 
            Case Event1["Type"]="KEY" :
                 Object.HotKey=EVENT1["KeyCode"]
                 If isassigned(Object.Hotkeys[Object.HotKey]) then
                    Object.Handle=Object.Hotkeys[Object.HotKey]
                    
Object.String=Object.Handles[Object.HotKeys[Object.HotKey]]
                 Else 
                    loop
                 Endif           
         EndSwitch
         Retval=Match(Object.String,
                "..,..,..,..,..,..,..,..,..,..,..,..,..",
                     ProcName,
                     Freq,
                     Dur,
                     AtRow,
                     AtCol,
                     High,
                     Wide,
                     GUI,
                     Floating,
                     Label,
                     ColorOut,
                     ColorIn,
                     HotKey)
         
         High=numval(High)
         Wide=numval(Wide)
         Freq=Numval(Freq)
         Dur=Numval(Dur)
         ColorIn=Numval(ColorIn)
         ColorOut=Numval(ColorOut)

         SetCanvas(Object.Handle)
         Canvas Off   
         PaintCanvas Attribute ColorIn All
         If Upper(StrVal(GUI))="TRUE" then
            PaintCanvas Border Attribute 127 0,0,High-1,Wide-1
            PaintCanvas Border Attribute 112 0,0,0,Wide-2
            PaintCanvas Border Attribute 112 0,0,High-1,0
         Endif
         Canvas On
         
         If Dur>0 and Freq>0 then
            Sound Freq Dur
         Endif   
         
         Canvas Off
         PaintCanvas Attribute ColorOut All
         If Upper(StrVal(GUI))="TRUE" then
            PaintCanvas Border Attribute 112 0,0,High-1,Wide-1
            PaintCanvas Border Attribute 127 0,0,0,Wide-2
            PaintCanvas Border Attribute 127 0,0,High-1,0
         Endif
         Canvas On

         If Not isblank(ProcName) then
            ExecProc ProcName
         Endif
         
         If not isassigned(Object.Handles) then
            Quitloop
         Endif     
      EndWhile   
     
EndProc
Writelib LibName Objects.Events      
release Procs Objects.Events

Proc OBJECTS.DESTROY()
     Private I

     ForEach I in Object.Handles
       Window Select NumVal(I)
       Window Close
     EndForEach
       
     Release Vars Object.HotKeys
     Release Vars Object.Handles
          
     Return False
EndProc
Writelib LibName Objects.Destroy      
release Procs Objects.Destroy

;Object Oriented Construction Tools --
;Construct an Object Oriented Piano 
;Paradox 4.0 

Proc CancelNotes()
     If isblank(Music) then
        Objects.Destroy()
     else
        Music=""
        PianoCursor=1
        RefreshNotes()
     endif      
EndProc
Writelib Libname CancelNotes
Release Procs CancelNotes

Proc PlayNotes()
     Private TempCursor,i,Note
     TempCursor=PianoCursor
     
     For PianoCursor from PianoCursor to Len(Music)
          If Charwaiting() then
             quitloop
          endif      
          PianoCursor()
          SoundOff()
     endfor
     PianoCursor=TempCursor
     PianoCursor()
EndProc
Writelib Libname PlayNotes
Release Procs PlayNotes

Proc PlayMusic()
     If not isassigned(MusicEditorFlag) then
       For PianoCursor from 1 to Len(Music)
          If Charwaiting() then
             quitloop
          endif      
          SoundOff()
       endfor
     endif
EndProc
Writelib Libname PlayMusic
Release Procs PlayMusic

Proc InsertNote()
     Music=SubStr(Music,1,PianoCursor-1)+Chr(40)+
           Substr(Music,PianoCursor,Len(Music)-PianoCursor+1)
     If Len(Music)>70 then
        Music=Substr(music,1,70)
     endif         
     PianoCursor=Min(PianoCursor+1,70)      
     RefreshNotes()
EndProc
Writelib Libname InsertNote
Release Procs InsertNote

Proc DeleteNote()
     If Len(Music)<=1 then 
        Music=""
     else   
        If PianoCursor>=Len(Music) then
           Music=SubStr(Music,1,PianoCursor-1)
        Else   
           Music=SubStr(Music,1,PianoCursor-1)+
                 Substr(Music,PianoCursor+1,Len(Music)-PianoCursor)
        Endif
     endif
     PianoCursor=Min(PianoCursor+1,Len(Music)+1)
     RefreshNotes()
EndProc
Writelib Libname DeleteNote
Release Procs DeleteNote

Proc RefreshNotes()
     Private i,Note
     setcanvas MeterWin 
     Paintcanvas fill "" background 1,1,12,70
     For i from 1 to Len(Music)
          Note=10*(Asc(Substr(music,i,1))-40)
          RefreshNote(i,Note)
     endfor
     BackOne()
endproc
Writelib Libname RefreshNotes
Release Procs RefreshNotes
 
Proc PianoCursor()
     Window Move Cursorwin to 2,PianoCursor+4
EndProc
Writelib Libname PianoCursor
Release Procs PianoCursor

Proc JumpCursor()
     PianoCursor=Min(Event1["Col"]-4,Len(Music)+1)
     PianoCursor()
EndProc
Writelib Libname JumpCursor
Release Procs JumpCursor

Proc BackOne()
     PianoCursor=Max(PianoCursor-1,1)
     PianoCursor()
EndProc
Writelib Libname BackOne
Release Procs BackOne

Proc SoundOff()
     Note=10*(Asc(Substr(music,PianoCursor,1))-40)
     If Note>0 and Note<10000 then
        Sound Note 100
     else
        sleep 100
     endif      
     Sleep 100
EndProc
Writelib Libname SoundOff
Release Procs SoundOff

Proc ForwardOne()
     if PianoCursor<=Len(Music) then
        SoundOff()
     endif 
     PianoCursor=Min(PianoCursor+1,Min(len(Music)+1,70))
     PianoCursor()
EndProc
Writelib Libname ForwardOne
Release Procs ForwardOne

Proc Note()
     Private Note
  
     Note = Chr(40+Int(Freq/10))
     If Len(Music)=PianoCursor-1 then
        Music = Music + Note
     else
        if PianoCursor=1 then
           if Len(Music)=1 then
              Music=Note
           else
              Music=Note+SubStr(Music,2,len(Music)-1)
              
           endif
        else   
           Music=Substr(Music,1,PianoCursor-1)+Note+
                 Substr(Music,PianoCursor+1,Len(Music)-PianoCursor)      
        endif    
     Endif
     If len(Music)>70 then
        Music=substr(Music,1,70)
     endif   
     RefreshNote(PianoCursor,Freq)
     PianoCursor=Min(PianoCursor+1,Min(Len(Music)+1,70))
     PianoCursor()
EndProc
Writelib Libname Note
Release Procs Note

Proc RefreshNote(PianoCursor,Freq)
     SetCanvas MeterWin
     PaintCanvas Fill Fill("",12-int(Freq/175))+Fill("",12) 
                 Background 1,PianoCursor,12,PianoCursor
EndProc
Writelib Libname RefreshNote
Release Procs RefreshNote
     
Proc SaveNotes()
     Private Fil
     
     Savevars Autolib,Music
     FileRead Privdir()+"Savevars.sc" to Fil
     Fil=Fil + "\nPlayMusic() \n"
     FileWrite MusicFil+".Sc" From Fil
EndProc
Writelib Libname SaveNotes
Release Procs SaveNotes

Proc OOPiano(MusicFil)
   Private MusicEditorFlag
   MusicEditorFlag=True

   ;(I) Initialize Object Oriented Enviornment Variables
   ;-----------------------------------------------
   Objects.Initialize()
   Music=""
   PianoCursor=1
   
   ;(II) Create Objects - (Build Our Piano)
   ;------------------------------------------------
   ;(Background Panel)
   Objects.Create("",4000,1,0,0,25,80,True,True,"",126,126,-69)     
   Objects.Create("JumpCursor",4000,1,1,4,14,72,True,True,"",2,5,-69)     
   MeterWin=GetWindow()  ; 
   Objects.Create("",4000,1,0,28,1,24,false,True,Format("W24,ac","The 
OOPiano Composer"),116,112,-69)
   
Objects.Create("",4000,1,1,33,1,14,false,True,Format("W15,ac",MusicFil+"
.SC"),127,112,-69)
   Objects.Create("",4000,1,2,5,1,1,False,True,Chr(14),132,15,-69)
   CursorWin=GetWindow()     
   
   ;(Bottom Control Buttons)
   
Objects.Create("CancelNotes",4000,1,21,4,3,8,True,True,"Cancel",113,127,
27)     
   Objects.Create("SaveNotes",4000,1,21,13,3,8,True,True," Save 
",113,127,-60)     
   Objects.Create("BackOne",4000,1,21,22,3,8,True,True,"  <<  
",116,127,-75)    
   Objects.Create("Note",0,1,21,31,3,8,True,True," Rest ",116,127,32)     
   Objects.Create("PlayNotes",4000,1,21,40,3,8,True,True,"  
"+Chr(14)+Chr(13)+"  ",116,127,13)     
   Objects.Create("ForwardOne",4000,1,21,49,3,8,True,True,"  >>  
",116,127,-77)    
   
Objects.Create("InsertNote",4000,1,21,58,3,8,True,True,"Insert",112,127,
-82)    
   
Objects.Create("DeleteNote",4000,1,21,67,3,8,True,True,"Delete",112,127,
-83)    
   
   ;(White Piano Keys)
   Objects.Create("NOTE",0010,100,15,09,5,3,True,True,"",112,127,126)
   Objects.Create("NOTE",0100,100,15,12,5,3,True,True,"",112,127,33)     
   Objects.Create("NOTE",0200,100,15,15,5,3,True,True,"",112,127,64)     
   Objects.Create("NOTE",0300,100,15,18,5,3,True,True,"",112,127,35)     
   Objects.Create("NOTE",0400,100,15,21,5,3,True,True,"",112,127,36)     
   Objects.Create("NOTE",0500,100,15,24,5,3,True,True,"",112,127,37)     
   Objects.Create("NOTE",0600,100,15,27,5,3,True,True,"",112,127,94)   
   Objects.Create("NOTE",0700,100,15,30,5,3,True,True,"",112,127,96)   
   Objects.Create("NOTE",0800,100,15,33,5,3,True,True,"",112,127,49)     
   Objects.Create("NOTE",0900,100,15,36,5,3,True,True,"",112,127,50)     
   Objects.Create("NOTE",1000,100,15,39,5,3,True,True,"",112,127,51)     
   Objects.Create("NOTE",1100,100,15,42,5,3,True,True,"",112,127,52)     
   Objects.Create("NOTE",1200,100,15,45,5,3,True,True,"",112,127,53)     
   Objects.Create("NOTE",1300,100,15,48,5,3,True,True,"",112,127,54)     
   Objects.Create("NOTE",1400,100,15,51,5,3,True,True,"",112,127,55) 
   Objects.Create("NOTE",1500,100,15,54,5,3,True,True,"",112,127,56)    
   Objects.Create("NOTE",1600,100,15,57,5,3,True,True,"",112,127,57)    
   Objects.Create("NOTE",1700,100,15,60,5,3,True,True,"",112,127,48)    
   Objects.Create("NOTE",1800,100,15,63,5,3,True,True,"",112,127,45)    
   Objects.Create("NOTE",1900,100,15,66,5,3,True,True,"",112,127,61)    
   Objects.Create("NOTE",2000,100,15,69,5,3,True,True,"",112,127,92)    
   
   ;(Black Piano Keys)
   Objects.Create("NOTE",0050,100,15,11,3,2,False,True," ",15,8,81)     
   Objects.Create("NOTE",0150,100,15,14,3,2,False,True," ",15,8,87)     
   Objects.Create("NOTE",0350,100,15,20,3,2,False,True," ",15,8,69)     
   Objects.Create("NOTE",0450,100,15,23,3,2,False,True," ",15,8,82)     
   Objects.Create("NOTE",0550,100,15,26,3,2,False,True," ",15,8,84)     
   Objects.Create("NOTE",0750,100,15,32,3,2,False,True," ",15,8,113)    
   Objects.Create("NOTE",0850,100,15,35,3,2,False,True," ",15,8,119)    
   Objects.Create("NOTE",1050,100,15,41,3,2,False,True," ",15,8,101)    
   Objects.Create("NOTE",1150,100,15,44,3,2,False,True," ",15,8,114)    
   Objects.Create("NOTE",1250,100,15,47,3,2,False,True," ",15,8,116)    
   Objects.Create("NOTE",1450,100,15,53,3,2,False,True," ",15,8,121)    
   Objects.Create("NOTE",1550,100,15,56,3,2,False,True," ",15,8,117)    
   Objects.Create("NOTE",1750,100,15,62,3,2,False,True," ",15,8,105)    
   Objects.Create("NOTE",1850,100,15,65,3,2,False,True," ",15,8,111)    
   Objects.Create("NOTE",1950,100,15,68,3,2,False,True," ",15,8,112)    

   Music=""
   If isFile(MusicFil+".SC") then
      play MusicFil
      RefreshNotes()
   endif  

   ;(III) Call The Event Handler - (Play The Piano)
   ;-----------------------------------------
   Objects.Events()

EndProc
Writelib Libname OOPiano
release Procs OOPiano

Autolib="OOPiano"
 
OOPiano("OOPMusic")  ;Script Name Without Extension - To Save Sound 
File.

